Unit IAC1R3_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, IAC1R1_p, IAS1R2_p;

procedure IAC1R3(var TX :Array of Real; NX :Integer;
                var CX :Array of Real; LX :Integer; MXA :Integer;
                MXB :Integer; var AC :Array of Real;
                var BC :Array of Real);

implementation

procedure IAC1R3(var TX :Array of Real; NX :Integer;
                var CX :Array of Real; LX :Integer; MXA :Integer;
                MXB :Integer; var AC :Array of Real;
                var BC :Array of Real);
var
I,J,K,L :Integer;
A,B,C,D,E,F,G :Real;
const
C0 :Real = 0.0;
C1 :Real = 1.0;
K0 :Integer = 0;
K1 :Integer = 1;
K2 :Integer = 2;
K3 :Integer = 3;
K4 :Integer = 4;
label
_10,_20,_30,_40,_50;
begin
I  := K4 + K2;
for J:=K1 to I do
 begin
  CX[J-1] := C0;
  K  := NX + I - K1 - J;
  CX[K-1] := C0;
_10:
 end;
I  := NX + K1;
J  := I + K1;
K  := J + K1;
L  := K + K1;
B  := C1;
CX[K1-1] := C1;
A  := IAS1R2(TX,CX,K4,MXA,TX[K3-1],K3,K1);
if ( LX  =  K0 ) 
 then goto _30;
B  := IAC1R1(TX,CX,LX,K2);
CX[K1-1] := C0;
CX[K2-1] := C1;
C  := IAC1R1(TX,CX,LX,K3);
if ( MXA  >  K0 ) 
 then goto _20;
D  := IAS1R2(TX,CX,K4,K0,TX[K4-1],K4,K1);
CX[K2-1] := 0;
AC[K2-1] := C1/C/D;
goto _30;
_20:
E  := IAS1R2(TX,CX,K4,K0,TX[K3-1],K3,K1);
F  := IAS1R2(TX,CX,K4,MXA,TX[K3-1],K3,K1);
CX[K2-1] := C0;
CX[K1-1] := C1;
G  := IAS1R2(TX,CX,K4,K0,TX[K3-1],K3,K1);
D  := G*F - E*A;
AC[K3-1] := G/D/C;
AC[K2-1] := A/D/C;
A  := G;
_30:
CX[K1-1] := C0;
AC[K1-1] := C1/A/B;
CX[J-1] := C1;
A  := IAS1R2(TX,CX,K4,MXB,TX[J-1],I,K1);
if ( LX  =  K0 ) 
 then goto _50;
CX[J-1] := C0;
CX[L-1] := C1;
B  := IAC1R1(TX,CX,LX,K);
CX[L-1] := C0;
CX[K-1] := C1;
C  := IAC1R1(TX,CX,LX,J);
CX[K-1] := C0;
CX[I-1] := C1;
if ( MXB  >  K0 ) 
 then goto _40;
D  := IAS1R2(TX,CX,K4,MXB,TX[I-1],I,K1);
CX[I-1] := C0;
BC[K2-1] := C1/C/D;
goto _50;
_40:
E  := IAS1R2(TX,CX,K4,K0,TX[J-1],I,K1);
F  := IAS1R2(TX,CX,K4,MXB,TX[J-1],I,K1);
CX[I-1] := C0;
CX[J-1] := C1;
G  := IAS1R2(TX,CX,K4,K0,TX[J-1],I,K1);
D  := G*F - E*A;
BC[K3-1] := G/D/C;
BC[K2-1] := A/D/C;
A  := G;
_50:
CX[J-1] := C0;
BC[K1-1] := C1/A/B;
end;

end.
