Unit IAC1R4_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, IAC1R1_p, IAS1R2_p;

procedure IAC1R4(var TX :Array of Real; NX :Integer;
                var CX :Array of Real; LX :Integer; MXA :Integer;
                FXA :Real; MXB :Integer; FXB :Real;
                var AC :Array of Real; var BC :Array of Real);

implementation

procedure IAC1R4(var TX :Array of Real; NX :Integer;
                var CX :Array of Real; LX :Integer; MXA :Integer;
                FXA :Real; MXB :Integer; FXB :Real;
                var AC :Array of Real; var BC :Array of Real);
var
I,J,K,L,M :Integer;
B,C :Real;
A :Array [0..3] of Real;
const
C0 :Real = 0.0;
K0 :Integer = 0;
K1 :Integer = 1;
K2 :Integer = 2;
K3 :Integer = 3;
K4 :Integer = 4;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120;
begin
CX[K1-1] := C0;
CX[K2-1] := C0;
K  := NX + K3;
L  := K + K1;
CX[K-1] := C0;
CX[L-1] := C0;
M  := MXA;
for I:=K1 to K4 do
 begin
  J  := I + K1;
  A[I-1] := IAC1R1(TX,CX,LX,J);
_10:
 end;
if ( M  >  K0  ) or (  LX  =  K0 ) 
 then goto _30;
C  := IAS1R2(TX,A,K4,K0,TX[K4-1],K3,K0);
CX[K2-1] := (CX[K4-1] - C)*AC[K2-1];
_20:
A[K1-1] := IAC1R1(TX,CX,LX,K2);
A[K2-1] := IAC1R1(TX,CX,LX,K3);
_30:
C  := IAS1R2(TX,A,K4,M,TX[K3-1],K3,K0);
if ( M  >  K0 ) 
 then goto _40;
J  := K2 - LX;
CX[J-1] := (CX[K3-1] - C)*AC[K1-1];
goto _60;
_40:
if ( LX  =  K1 ) 
 then goto _50;
CX[K2-1] := (FXA - C)*AC[K1-1];
goto _60;
_50:
B  := IAS1R2(TX,A,K4,K0,TX[K3-1],K3,K0);
CX[K2-1] := AC[K3-1]*(FXA - C) - AC[K2-1]*(CX[K3-1] - B);
M  := K0;
goto _20;
_60:
M  := MXB;
K  := K - K1;
L  := K - K1;
for I:=K1 to K4 do
 begin
  J  := K - K3 + I;
  A[I-1] := IAC1R1(TX,CX,LX,J);
_70:
 end;
if ( M  >  K0  ) or (  LX  =  K0 ) 
 then goto _90;
C  := IAS1R2(TX,A,K4,K0,TX[L-1],L,K0);
CX[J-1] := (CX[L-1] - C)*BC[K2-1];
_80:
A[K3-1] := IAC1R1(TX,CX,LX,K);
A[K4-1] := IAC1R1(TX,CX,LX,J);
_90:
C  := IAS1R2(TX,A,K4,M,TX[K-1],L,K0);
if ( M  >  K0 ) 
 then goto _100;
J  := J + LX;
CX[J-1] := (CX[K-1] - C)*BC[K1-1];
goto _120;
_100:
if ( LX  =  K1 ) 
 then goto _110;
CX[J-1] := (FXB - C)*BC[K1-1];
goto _120;
_110:
B  := IAS1R2(TX,A,K4,K0,TX[K-1],L,K0);
CX[J-1] := BC[K3-1]*(FXB - C) - BC[K2-1]*(CX[K-1] - B);
M  := K0;
goto _80;
_120:
end;

end.
